package org.wfc.omada.api.monitor.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * ListTabs
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:38:12.484+08:00[Asia/Shanghai]")

public class ListTabs   {
  @JsonProperty("id")
  private String id;

  @JsonProperty("name")
  private String name;

  @JsonProperty("type")
  private Integer type;

  @JsonProperty("cards")
  @Valid
  private List<Integer> cards = null;

  public ListTabs id(String id) {
    this.id = id;
    return this;
  }

  /**
   * A unique identifier
   * @return id
  */
  @ApiModelProperty(value = "A unique identifier")


  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public ListTabs name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Name cannot be duplicated on the dashboard page, it should contain 1 to 64 characters.
   * @return name
  */
  @ApiModelProperty(value = "Name cannot be duplicated on the dashboard page, it should contain 1 to 64 characters.")


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ListTabs type(Integer type) {
    this.type = type;
    return this;
  }

  /**
   * Type should be a value as follows: 1: Network; 2: Clients; 3: Customized.
   * @return type
  */
  @ApiModelProperty(value = "Type should be a value as follows: 1: Network; 2: Clients; 3: Customized.")


  public Integer getType() {
    return type;
  }

  public void setType(Integer type) {
    this.type = type;
  }

  public ListTabs cards(List<Integer> cards) {
    this.cards = cards;
    return this;
  }

  public ListTabs addCardsItem(Integer cardsItem) {
    if (this.cards == null) {
      this.cards = new ArrayList<>();
    }
    this.cards.add(cardsItem);
    return this;
  }

  /**
   * Card list displayed in Tab. Each number indicates a type of card. card should be a value as follows:  0: Controller Snapshot, 101: Alerts, 102: ISP Load, 103: L2TP/PPTP VPN, 104: Channel Distribution and Usage, 105: Most Active EAPs, 106: Most Active Switches, 108: WiFi/Switching Summary, 109: Traffic Distribution, 110: Traffic Activities, 111: Clients Distribution, 112: Retry Rate/Dropped Rate, 117: Top Device CPU/Memory Usage, 118: IPSEC VPN, 119: OPEN VPN, 120: SSL VPN, 200: Most Active Clients, 201: Longest client uptime, 202: Clients Freq Distribution, 203: Clients Activities, 204: Clients Association Activities, 205: Association Failures, 206: Clients Association Time Distribution, 207: Clients SSID Distribution, 208: Clients RSSI Distribution
   * @return cards
  */
  @ApiModelProperty(value = "Card list displayed in Tab. Each number indicates a type of card. card should be a value as follows:  0: Controller Snapshot, 101: Alerts, 102: ISP Load, 103: L2TP/PPTP VPN, 104: Channel Distribution and Usage, 105: Most Active EAPs, 106: Most Active Switches, 108: WiFi/Switching Summary, 109: Traffic Distribution, 110: Traffic Activities, 111: Clients Distribution, 112: Retry Rate/Dropped Rate, 117: Top Device CPU/Memory Usage, 118: IPSEC VPN, 119: OPEN VPN, 120: SSL VPN, 200: Most Active Clients, 201: Longest client uptime, 202: Clients Freq Distribution, 203: Clients Activities, 204: Clients Association Activities, 205: Association Failures, 206: Clients Association Time Distribution, 207: Clients SSID Distribution, 208: Clients RSSI Distribution")


  public List<Integer> getCards() {
    return cards;
  }

  public void setCards(List<Integer> cards) {
    this.cards = cards;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ListTabs listTabs = (ListTabs) o;
    return Objects.equals(this.id, listTabs.id) &&
        Objects.equals(this.name, listTabs.name) &&
        Objects.equals(this.type, listTabs.type) &&
        Objects.equals(this.cards, listTabs.cards);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, type, cards);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ListTabs {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    cards: ").append(toIndentedString(cards)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

